package Logoved::Role::Stream::Out::Listener::Repocop::Test;
use strict;
use warnings;
use Moo::Role;
with 'Logoved::Role::Stream::Out::Listener::Repocop';

has ignore => (is => 'rw', default => 0);
has test => (is => 'rw', default => 'posttest');
has status => (is => 'rw', default => 'experimental');
has barename => (is => 'rw');
has message_prefix => (is => 'rw', default => sub { '' });
has messages => (is => 'ro', default => sub { [] });

sub notify_receiver {
    my $self=shift;
    my $messages_ref=$self->messages;
    return if $self->ignore or not @$messages_ref;
    my $message=join('', (defined ($self->message_prefix) ? $self->message_prefix : ''), @$messages_ref);
    my @notification=(
	-test => $self->test,
	-status => $self->status,
	-barename => $self->barename,
	-message => $message,
	);
    my $stream=$self->stream;
    if (!$stream->is_unique) {
	my $messager=$stream->messager;
	my $section_nvr=$messager->get_message('section_nvr');
	push @notification, -section_nvr => $section_nvr if defined($section_nvr);
    }
    $self->receptor->notify_repocop(@notification);
}

sub commit {
    my $self=shift;
    my $messages_ref=$self->messages;
    $self->notify_receiver() if @$messages_ref;
    @$messages_ref=();
}

sub DEMOLISH {
    my $self=shift;
    my $messages_ref=$self->messages;
    if (@$messages_ref) {
	warn 'Listener::Repocop: internal: ',ref($self), ': not commited properly.';
	$self->commit();
    }
}

1;
