package Logoved::Stream::Out::Listener::Repocop::FileDump;
use autodie qw/open close/;
use Moo;

has 'stream' => (is => 'ro');
has 'outfile' => (is => 'ro');
has 'buffer' => (is=>'ro', default => sub { [] });

# -test = 'beehive-log-' .{-barename}. '-'.$arch,
sub notify_repocop {
    my $self=shift;
    my $in={@_};
    push @{$self->buffer},$in;
};

sub commit {
    my $self=shift;
    my $outfile=$self->outfile;
    return unless defined($outfile);
    my $messager=$self->stream->messager;
    my $arch=$messager->get_message('target');
    $arch//='unknown';
    my $srcid=$messager->get_message('wrote:src.rpm');
    $srcid//=$messager->get_message('in:src.rpm');
    $srcid=~s/\.rpm$//;
    my $rpmlistref=$messager->get_message('wrote:rpms');
    my %nvr2archid;
    foreach my $archid (@$rpmlistref) {
	$archid=~s/\.rpm$//;
	my $nvr=$archid;
	$nvr=~s/\.[^\.]+$//;
	$nvr2archid{$nvr}=$archid;
    }
    open (my $fh, '>', $outfile);
    foreach my $report (@{$self->buffer}) {
	$report->{-arch}=$arch;
	$report->{-sourceid}=$srcid;
	my $section_nvr=$report->{-section_nvr};
	if ($section_nvr and $nvr2archid{$section_nvr}) {
	    $report->{-pkgid}=$nvr2archid{$section_nvr};
	}
	&print_fh($fh,$report);
    }
    close($fh);
    @{$self->buffer}=();
}

sub DEMOLISH {
    my $self=shift;
    if (scalar @{$self->buffer}) {
	warn 'Repocop Receptor: internal: ',$self->outfile, ': not commited properly.';
	$self->commit();
    }
}

sub print_fh {
    my ($fh,$in)=@_;
    my $testname='beehive-log-'.$in->{-barename}.'-'.$in->{-arch};
    my $id=$in->{-pkgid};
    $id//=$in->{-sourceid};
    my $message=$in->{-message};
    chomp $message;
    $message=~s/\n/<br>/g;
    if ($fh) {
	print $fh $id,"\t",$testname,"\t",$in->{-status},"\t",$message,"\n";
    } else {
	print $id,"\t",$testname,"\t",$in->{-status},"\t",$message,"\n";
    }
}

1;
