package Logoved::Stream::Out::Listener::Repocop::posttest::files::misc;
use Moo;
with 'Logoved::Role::Stream::Out::Listener::Repocop::Test';

sub subscribe_stream {
    my ($class, $stream)=@_;
    return 1 if $stream->section_type eq 'rpmbuild::files::find_provides';
    return 1 if $stream->section_type eq 'rpmbuild::files::find_requires';
    return 0;
}

sub write {
    my ($self, $line)=@_;
    #debuginfo.req: WARNING: /usr/lib64/libsignon-qt5.so.1 is not yet debuginfo-enabled
   
    if ($line=~m!^debuginfo.req: WARNING: .* is not yet debuginfo-enabled!) {
	#push @{$self->messages}, $line;
	return 1;
    #debuginfo.req: WARNING: /usr/lib64/torcs/trackgen-bin: library libtgfclient.so not found
    } elsif ($line=~m!^debuginfo.req: WARNING: /.*: library .* not found!) {
	return 1;
    #debuginfo.req: WARNING: /usr/src/tmp/freeipmi-buildroot/usr/sbin/ipmi-console: objdump failed
    } elsif ($line=~m!^debuginfo.req: WARNING: /.*: objdump failed!) {
	return 1;
    #shebang.req: WARNING: /usr/src/tmp/icmake-buildroot/usr/bin/icmstart: too many arguments: #!/usr/bin/icmake -qt /tmp/icmstart
    } elsif ($line=~m!^shebang.req: WARNING: /.*: too many arguments: !) {
	return 1;
    #debuginfo.prov: WARNING: /usr/src/tmp/freeipmi-buildroot/usr/sbin/ipmi-console: objdump failed
    } elsif ($line=~m!^debuginfo.prov: WARNING: /.*: objdump failed!) {
	return 1;

    # random garbage
    #dpkg-shlibdeps: error: dpkg --print-architecture failed: No such file or directory
    } elsif ($line=~m!: error: dpkg --print-architecture failed: No such file or directory!) {
	return 1;
    # perl -c for dvdrip
    # ERROR: 'dvdrip.*' not found in PATH
    } elsif ($line=~m!^ERROR: 'dvdrip.*' not found in PATH!) {
	return 1;
    }
    return 0;
}

sub BUILD {
    my ($self)=shift;
    $self->status('experimental');
    $self->barename('misc');
    $self->ignore(1);
}

1;
