package Logoved::Stream::Out::Listener::Repocop::posttest::unpackaged_files_found;
use Moo;
with 'Logoved::Role::Stream::Out::Listener::Repocop::Test';

has 'in_warning' => (is => 'rw', default => 0);

sub subscribe_stream {
    my ($class, $stream)=@_;
    return $stream->section_type eq 'rpmbuild::unpackaged';
}

sub BUILD {
    my ($self)=shift;
    $self->status('info');
    $self->barename('unpackaged-files-found');
}

my $unpackaged_files_catchphrase=qr'^warning: Installed \(but unpackaged\) file\(s\) found:';

sub write {
    my ($self, $line)=@_;
    if ($self->in_warning) {
	if ($line=~ m!    /!) {
	    $line=~s/^\s*//;
	    push @{$self->messages}, $line;
	    return 1;
	} else {
	    $self->in_warning(0);
	}
    } elsif ($line=~ $unpackaged_files_catchphrase) {
	$self->in_warning(1);
	push @{$self->messages}, 'warning: Installed (but unpackaged) file(s) found:'."\n";
	return 1;
    }
    return 0;
}

1;
